Up

# NSTextView

### Authors

Scott Christley (`scottc@net-community.com`)
Felipe A. Rodriguez (`far@ix.netcom.com`)
Daniel Boehringer (`boehring@biomed.ruhr-uni-bochum.de`)
Fred Kiefer (`FredKiefer@gmx.de`)
Nicola Pero (`n.pero@mi.flashnet.it`)
Pierre-Yves Rivaille (`pyrivail@ens-lyon.fr`)

Copyright: (C) 1996, 1998, 2000, 2001, 2002, 2003, 2008 Free Software Foundation, Inc.

### Contents -

1. Software documentation for the NSTextView class
2. Software documentation for the NSObject(NSTextViewDelegate) informal protocol
3. Software documentation for the NSTextView(GSTextViewSync) category
4. Software documentation for the NSTextView(UserActions) category
5. Software documentation for the NSTextView(leftovers) category

# Software documentation for the NSTextView class

## NSTextView : NSText

> Declared in:
>   AppKit/NSTextView.h

> Conforms to:
>   NSTextInput
>   NSUserInterfaceValidations

Availability: OpenStep
Description forthcoming.

Instance Variables
Method summary

- -_layoutManagerDidInvalidateLayout
- -_recacheDelegateResponses
- -_syncTextViewsByCalling:withFlag:
- -_updateMultipleTextViews
- -alignJustified:
- -loosenKerning:
- -lowerBaseline:
- -outline:
- -raiseBaseline:
- -setBaseWritingDirection:range:
- -tightenKerning:
- -toggleBaseWritingDirection:
- -toggleContinuousSpellChecking:
- -toggleTraditionalCharacterShape:
- -transpose:
- -turnOffKerning:
- -turnOffLigatures:
- -useAllLigatures:
- -useStandardKerning:
- -useStandardLigatures:
- -acceptableDragTypes
- -acceptsGlyphInfo
- -allowsDocumentBackgroundColorChange
- -breakUndoCoalescing
- -changeAttributes:
- -changeDocumentBackgroundColor:
- -cleanUpAfterDragOperation
- -clickedOnLink:atIndex:
- -complete:
- -completionsForPartialWordRange:indexOfSelectedItem:
- -dragImageForSelectionWithEvent:origin:
- -dragOperationForDraggingInfo:type:
- -dragSelectionWithEvent:offset:slideBack:
- -drawInsertionPointInRect:color:turnedOn:
- -drawViewBackgroundInRect:
- -insertCompletion:forPartialWordRange:movement:isFinal:
- -orderFrontLinkPanel:
- -orderFrontListPanel:
- -orderFrontTablePanel:
- -performFindPanelAction:
- -preferredPasteboardTypeFromArray:restrictedToTypesFromArray:
- -readSelectionFromPasteboard:
- -readSelectionFromPasteboard:type:
- -readablePasteboardTypes
- -rulerView:didAddMarker:
- -rulerView:didMoveMarker:
- -rulerView:didRemoveMarker:
- -rulerView:handleMouseDown:
- -rulerView:shouldAddMarker:
- -rulerView:shouldMoveMarker:
- -rulerView:shouldRemoveMarker:
- -rulerView:willAddMarker:atLocation:
- -rulerView:willMoveMarker:toLocation:
- -selectedRanges
- -selectionAffinity
- -selectionGranularity
- -selectionRangeForProposedRange:granularity:
- -setAcceptsGlyphInfo:
- -setAllowsDocumentBackgroundColorChange:
- -setNeedsDisplayInRect:avoidAdditionalLayout:
- -setSelectedRange:
- -setSelectedRange:affinity:stillSelecting:
- -setSelectedRanges:
- -setSelectedRanges:affinity:stillSelecting:
- -setSelectionGranularity:
- -setTypingAttributes:
- -shouldDrawInsertionPoint
- -smartDeleteRangeForProposedRange:
- -smartInsertForString:replacingRange:beforeString:afterString:
- -spellCheckerDocumentTag
- -startSpeaking:
- -stopSpeaking:
- -typingAttributes
- -updateDragTypeRegistration
- -updateFontPanel
- -updateInsertionPointStateAndRestartTimer:
- -updateRuler
- -validRequestorForSendType:returnType:
- -writablePasteboardTypes
- -writeSelectionToPasteboard:type:
- -writeSelectionToPasteboard:types:
- +defaultTypingAttributes
- +registerForServices
- -_updateInputMethodState
- -_updateInputMethodWithInsertionPoint:
- -allowsUndo
- -defaultParagraphStyle
- -didChangeText
- -initWithFrame:
- -initWithFrame:textContainer:
- -insertionPointColor
- -invalidateTextContainerOrigin
- -isContinuousSpellCheckingEnabled
- -layoutManager
- -linkTextAttributes
- -markedTextAttributes
- -pasteAsPlainText:
- -pasteAsRichText:
- -rangeForUserCharacterAttributeChange
- -rangeForUserCompletion
- -rangeForUserParagraphAttributeChange
- -rangeForUserTextChange
- -rangesForUserCharacterAttributeChange
- -rangesForUserParagraphAttributeChange
- -rangesForUserTextChange
- -replaceCharactersInRange:withAttributedString:
- -replaceCharactersInRange:withString:
- -replaceTextContainer:
- -selectedTextAttributes
- -setAlignment:range:
- -setAllowsUndo:
- -setConstrainedFrameSize:
- -setContinuousSpellCheckingEnabled:
- -setDefaultParagraphStyle:
- -setInsertionPointColor:
- -setLinkTextAttributes:
- -setMarkedTextAttributes:
- -setRulerVisible:
- -setSelectedTextAttributes:
- -setSmartInsertDeleteEnabled:
- -setTextContainer:
- -setTextContainerInset:
- -setUsesFindPanel:
- -setUsesRuler:
- -shouldChangeTextInRange:replacementString:
- -shouldChangeTextInRanges:replacementStrings:
- -smartInsertDeleteEnabled
- -textContainer
- -textContainerInset
- -textContainerOrigin
- -textStorage
- -usesFindPanel
- -usesRuler

### defaultTypingAttributes

+ (NSDictionary*) defaultTypingAttributes;
Availability: OpenStep
Returns the default typing attributes: black text, default paragraph style (as returned by [NSParagraphStyle defaultParagraphStyle]), and default user font and size (as returned by [NSFont userFontOfSize: 0.0]). GNUstep extension.

### registerForServices

+ (void) registerForServices;
Availability: OpenStep
Description forthcoming.

### _updateInputMethodState

- (void) _updateInputMethodState;
Availability: OpenStep
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _updateInputMethodWithInsertionPoint:

- (void) _updateInputMethodWithInsertionPoint: (NSPoint)insertionPoint;
Availability: OpenStep
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### allowsUndo

- (BOOL) allowsUndo;
Availability: OpenStep
Description forthcoming.

### defaultParagraphStyle

- (NSParagraphStyle*) defaultParagraphStyle;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### didChangeText

- (void) didChangeText;
Availability: OpenStep
Description forthcoming.

### initWithFrame:

- (id) initWithFrame: (NSRect)frameRect;
Availability: OpenStep
Description forthcoming.

### initWithFrame: textContainer:

- (id) initWithFrame: (NSRect)frameRect textContainer: (NSTextContainer*)container;
Availability: OpenStep
Description forthcoming.

### insertionPointColor

- (NSColor*) insertionPointColor;
Availability: OpenStep
Description forthcoming.

### invalidateTextContainerOrigin

- (void) invalidateTextContainerOrigin;
Availability: OpenStep
Description forthcoming.

### isContinuousSpellCheckingEnabled

- (BOOL) isContinuousSpellCheckingEnabled;
Availability: OpenStep
Description forthcoming.

### layoutManager

- (NSLayoutManager*) layoutManager;
Availability: OpenStep
Description forthcoming.

### linkTextAttributes

- (NSDictionary*) linkTextAttributes;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### markedTextAttributes

- (NSDictionary*) markedTextAttributes;
Availability: OpenStep
Description forthcoming.

### pasteAsPlainText:

- (void) pasteAsPlainText: (id)sender;
Availability: OpenStep
Description forthcoming.

### pasteAsRichText:

- (void) pasteAsRichText: (id)sender;
Availability: OpenStep
Description forthcoming.

### rangeForUserCharacterAttributeChange

- (NSRange) rangeForUserCharacterAttributeChange;
Availability: OpenStep
Description forthcoming.

### rangeForUserCompletion

- (NSRange) rangeForUserCompletion;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### rangeForUserParagraphAttributeChange

- (NSRange) rangeForUserParagraphAttributeChange;
Availability: OpenStep
Description forthcoming.

### rangeForUserTextChange

- (NSRange) rangeForUserTextChange;
Availability: OpenStep
Description forthcoming.

### rangesForUserCharacterAttributeChange

- (NSArray*) rangesForUserCharacterAttributeChange;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### rangesForUserParagraphAttributeChange

- (NSArray*) rangesForUserParagraphAttributeChange;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### rangesForUserTextChange

- (NSArray*) rangesForUserTextChange;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### replaceCharactersInRange: withAttributedString:

- (void) replaceCharactersInRange: (NSRange)aRange withAttributedString: (NSAttributedString*)aString;
Availability: OpenStep
Description forthcoming.

### replaceCharactersInRange: withString:

- (void) replaceCharactersInRange: (NSRange)aRange withString: (NSString*)aString;
Availability: OpenStep
Description forthcoming.

### replaceTextContainer:

- (void) replaceTextContainer: (NSTextContainer*)newContainer;
Availability: OpenStep
Description forthcoming.

### selectedTextAttributes

- (NSDictionary*) selectedTextAttributes;
Availability: OpenStep
Description forthcoming.

### setAlignment: range:

- (void) setAlignment: (NSTextAlignment)alignment range: (NSRange)range;
Availability: OpenStep
Description forthcoming.

### setAllowsUndo:

- (void) setAllowsUndo: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setConstrainedFrameSize:

- (void) setConstrainedFrameSize: (NSSize)desiredSize;
Availability: OpenStep
Description forthcoming.

### setContinuousSpellCheckingEnabled:

- (void) setContinuousSpellCheckingEnabled: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setDefaultParagraphStyle:

- (void) setDefaultParagraphStyle: (NSParagraphStyle*)style;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setInsertionPointColor:

- (void) setInsertionPointColor: (NSColor*)color;
Availability: OpenStep
Description forthcoming.

### setLinkTextAttributes:

- (void) setLinkTextAttributes: (NSDictionary*)attributeDictionary;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setMarkedTextAttributes:

- (void) setMarkedTextAttributes: (NSDictionary*)attributeDictionary;
Availability: OpenStep
Description forthcoming.

### setRulerVisible:

- (void) setRulerVisible: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setSelectedTextAttributes:

- (void) setSelectedTextAttributes: (NSDictionary*)attributeDictionary;
Availability: OpenStep
Description forthcoming.

### setSmartInsertDeleteEnabled:

- (void) setSmartInsertDeleteEnabled: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setTextContainer:

- (void) setTextContainer: (NSTextContainer*)container;
Availability: OpenStep
Description forthcoming.

### setTextContainerInset:

- (void) setTextContainerInset: (NSSize)inset;
Availability: OpenStep
Description forthcoming.

### setUsesFindPanel:

- (void) setUsesFindPanel: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setUsesRuler:

- (void) setUsesRuler: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### shouldChangeTextInRange: replacementString:

- (BOOL) shouldChangeTextInRange: (NSRange)affectedCharRange replacementString: (NSString*)replacementString;
Availability: OpenStep
Description forthcoming.

### shouldChangeTextInRanges: replacementStrings:

- (BOOL) shouldChangeTextInRanges: (NSArray*)ranges replacementStrings: (NSArray*)strings;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### smartInsertDeleteEnabled

- (BOOL) smartInsertDeleteEnabled;
Availability: OpenStep
Description forthcoming.

### textContainer

- (NSTextContainer*) textContainer;
Availability: OpenStep
Description forthcoming.

### textContainerInset

- (NSSize) textContainerInset;
Availability: OpenStep
Description forthcoming.

### textContainerOrigin

- (NSPoint) textContainerOrigin;
Availability: OpenStep
Description forthcoming.

### textStorage

- (NSTextStorage*) textStorage;
Availability: OpenStep
Description forthcoming.

### usesFindPanel

- (BOOL) usesFindPanel;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### usesRuler

- (BOOL) usesRuler;
Availability: OpenStep
Description forthcoming.

## Instance Variables for NSTextView Class

### _backgroundColor

@protected NSColor* _backgroundColor;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _currentInsertionPointMovementDirection

@protected int _currentInsertionPointMovementDirection;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _defaultParagraphStyle

@protected NSParagraphStyle* _defaultParagraphStyle;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _delegate

@protected id _delegate;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _dragTargetLocation

@protected unsigned int _dragTargetLocation;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _dragTargetUnused

@protected unsigned int _dragTargetUnused;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _drawInsertionPointNow

@protected BOOL _drawInsertionPointNow;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _insertionPointColor

@protected NSColor* _insertionPointColor;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _insertionPointRect

@protected NSRect _insertionPointRect;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _insertionPointTimer

@protected NSTimer* _insertionPointTimer;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _layoutManager

@protected NSLayoutManager* _layoutManager;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _linkTextAttributes

@protected NSDictionary* _linkTextAttributes;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _markedRange

@protected NSRange _markedRange;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _markedTextAttributes

@protected NSDictionary* _markedTextAttributes;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _maxSize

@protected NSSize _maxSize;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _minSize

@protected NSSize _minSize;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _notifObject

@protected NSTextView* _notifObject;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _originalInsertionPointCharacterIndex

@protected unsigned int _originalInsertionPointCharacterIndex;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _selectedTextAttributes

@protected NSDictionary* _selectedTextAttributes;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _spellCheckerDocumentTag

@protected int _spellCheckerDocumentTag;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _textContainer

@protected NSTextContainer* _textContainer;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _textContainerInset

@protected NSSize _textContainerInset;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _textContainerOrigin

@protected NSPoint _textContainerOrigin;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _textStorage

@protected NSTextStorage* _textStorage;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _tf

@protected struct GSTextViewFlagsType _tf;
Availability: OpenStep
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the NSObject(NSTextViewDelegate) informal protocol

## NSObject(NSTextViewDelegate)

> Declared in:
>   AppKit/NSTextView.h

Availability: MacOS-X 10.0.0
Description forthcoming.
Method summary

- -textView:clickedOnCell:inRect:
- -textView:clickedOnCell:inRect:atIndex:
- -textView:clickedOnLink:
- -textView:clickedOnLink:atIndex:
- -textView:completions:forPartialWordRange:indexOfSelectedItem:
- -textView:doCommandBySelector:
- -textView:doubleClickedOnCell:inRect:
- -textView:doubleClickedOnCell:inRect:atIndex:
- -textView:draggedCell:inRect:event:
- -textView:draggedCell:inRect:event:atIndex:
- -textView:shouldChangeTextInRange:replacementString:
- -textView:shouldChangeTextInRanges:replacementStrings:
- -textView:shouldChangeTypingAttributes:toAttributes:
- -textView:willChangeSelectionFromCharacterRange:toCharacterRange:
- -textView:willChangeSelectionFromCharacterRanges:toCharacterRanges:
- -textView:willDisplayToolTip:forCharacterAtIndex:
- -textViewDidChangeSelection:
- -textViewDidChangeTypingAttributes:
- -undoManagerForTextView:

### textView: clickedOnCell: inRect:

- (void) textView: (NSTextView*)textView clickedOnCell: (id<NSTextAttachmentCell>)cell inRect: (NSRect)cellFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: clickedOnCell: inRect: atIndex:

- (void) textView: (NSTextView*)textView clickedOnCell: (id<NSTextAttachmentCell>)cell inRect: (NSRect)cellFrame atIndex: (unsigned)charIndex;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: clickedOnLink:

- (BOOL) textView: (NSTextView*)textView clickedOnLink: (id)link;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: clickedOnLink: atIndex:

- (BOOL) textView: (NSTextView*)textView clickedOnLink: (id)link atIndex: (unsigned)charIndex;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: completions: forPartialWordRange: indexOfSelectedItem:

- (NSArray*) textView: (NSTextView*)textView completions: (NSArray*)words forPartialWordRange: (NSRange)range indexOfSelectedItem: (int*)index;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### textView: doCommandBySelector:

- (BOOL) textView: (NSTextView*)textView doCommandBySelector: (SEL)commandSelector;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: doubleClickedOnCell: inRect:

- (void) textView: (NSTextView*)textView doubleClickedOnCell: (id<NSTextAttachmentCell>)cell inRect: (NSRect)cellFrame;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: doubleClickedOnCell: inRect: atIndex:

- (void) textView: (NSTextView*)textView doubleClickedOnCell: (id<NSTextAttachmentCell>)cell inRect: (NSRect)cellFrame atIndex: (unsigned)charIndex;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: draggedCell: inRect: event:

- (void) textView: (NSTextView*)view draggedCell: (id<NSTextAttachmentCell>)cell inRect: (NSRect)rect event: (NSEvent*)event;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: draggedCell: inRect: event: atIndex:

- (void) textView: (NSTextView*)view draggedCell: (id<NSTextAttachmentCell>)cell inRect: (NSRect)rect event: (NSEvent*)event atIndex: (unsigned)charIndex;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: shouldChangeTextInRange: replacementString:

- (BOOL) textView: (NSTextView*)textView shouldChangeTextInRange: (NSRange)affectedCharRange replacementString: (NSString*)replacementString;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: shouldChangeTextInRanges: replacementStrings:

- (BOOL) textView: (NSTextView*)textView shouldChangeTextInRanges: (NSArray*)ranges replacementStrings: (NSArray*)strings;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### textView: shouldChangeTypingAttributes: toAttributes:

- (BOOL) textView: (NSTextView*)textView shouldChangeTypingAttributes: (NSDictionary*)oldAttribs toAttributes: (NSDictionary*)newAttribs;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### textView: willChangeSelectionFromCharacterRange: toCharacterRange:

- (NSRange) textView: (NSTextView*)textView willChangeSelectionFromCharacterRange: (NSRange)oldSelectedCharRange toCharacterRange: (NSRange)newSelectedCharRange;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textView: willChangeSelectionFromCharacterRanges: toCharacterRanges:

- (NSRange) textView: (NSTextView*)textView willChangeSelectionFromCharacterRanges: (NSArray*)oldSelectedCharRanges toCharacterRanges: (NSArray*)newSelectedCharRanges;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### textView: willDisplayToolTip: forCharacterAtIndex:

- (NSString*) textView: (NSTextView*)textView willDisplayToolTip: (NSString*)tooltip forCharacterAtIndex: (unsigned int)index;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### textViewDidChangeSelection:

- (void) textViewDidChangeSelection: (NSNotification*)notification;
Availability: MacOS-X 10.0.0
Description forthcoming.

### textViewDidChangeTypingAttributes:

- (void) textViewDidChangeTypingAttributes: (NSNotification*)notification;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### undoManagerForTextView:

- (NSUndoManager*) undoManagerForTextView: (NSTextView*)view;
Availability: MacOS-X 10.0.0
Description forthcoming.

# Software documentation for the NSTextView(GSTextViewSync) category

## NSTextView(GSTextViewSync)

> Declared in:
>   AppKit/NSTextView.h

Availability: OpenStep
Description forthcoming.
Method summary

- -_layoutManagerDidInvalidateLayout
- -_recacheDelegateResponses
- -_syncTextViewsByCalling:withFlag:
- -_updateMultipleTextViews

### _layoutManagerDidInvalidateLayout

- (void) _layoutManagerDidInvalidateLayout;
Availability: OpenStep
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _recacheDelegateResponses

- (void) _recacheDelegateResponses;
Availability: OpenStep
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _syncTextViewsByCalling: withFlag:

- (void) _syncTextViewsByCalling: (SEL)action withFlag: (BOOL)flag;
Availability: OpenStep
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

### _updateMultipleTextViews

- (void) _updateMultipleTextViews;
Availability: OpenStep
Warning the underscore at the start of the name of this method indicates that it is private, for internal use only, and you should not use the method in your code.

# Software documentation for the NSTextView(UserActions) category

## NSTextView(UserActions)

> Declared in:
>   AppKit/NSTextView.h

Availability: OpenStep
Description forthcoming.
Method summary

- -alignJustified:
- -loosenKerning:
- -lowerBaseline:
- -outline:
- -raiseBaseline:
- -setBaseWritingDirection:range:
- -tightenKerning:
- -toggleBaseWritingDirection:
- -toggleContinuousSpellChecking:
- -toggleTraditionalCharacterShape:
- -transpose:
- -turnOffKerning:
- -turnOffLigatures:
- -useAllLigatures:
- -useStandardKerning:
- -useStandardLigatures:

### alignJustified:

- (void) alignJustified: (id)sender;
Availability: OpenStep
Description forthcoming.

### loosenKerning:

- (void) loosenKerning: (id)sender;
Availability: OpenStep
Description forthcoming.

### lowerBaseline:

- (void) lowerBaseline: (id)sender;
Availability: OpenStep
Description forthcoming.

### outline:

- (void) outline: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### raiseBaseline:

- (void) raiseBaseline: (id)sender;
Availability: OpenStep
Description forthcoming.

### setBaseWritingDirection: range:

- (void) setBaseWritingDirection: (NSWritingDirection)direction range: (NSRange)range;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### tightenKerning:

- (void) tightenKerning: (id)sender;
Availability: OpenStep
Description forthcoming.

### toggleBaseWritingDirection:

- (void) toggleBaseWritingDirection: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### toggleContinuousSpellChecking:

- (void) toggleContinuousSpellChecking: (id)sender;
Availability: OpenStep
Description forthcoming.

### toggleTraditionalCharacterShape:

- (void) toggleTraditionalCharacterShape: (id)sender;
Availability: OpenStep
Description forthcoming.

### transpose:

- (void) transpose: (id)sender;
Availability: OpenStep
Description forthcoming.

### turnOffKerning:

- (void) turnOffKerning: (id)sender;
Availability: OpenStep
Description forthcoming.

### turnOffLigatures:

- (void) turnOffLigatures: (id)sender;
Availability: OpenStep
Description forthcoming.

### useAllLigatures:

- (void) useAllLigatures: (id)sender;
Availability: OpenStep
Description forthcoming.

### useStandardKerning:

- (void) useStandardKerning: (id)sender;
Availability: OpenStep
Description forthcoming.

### useStandardLigatures:

- (void) useStandardLigatures: (id)sender;
Availability: OpenStep
Description forthcoming.

# Software documentation for the NSTextView(leftovers) category

## NSTextView(leftovers)

> Declared in:
>   AppKit/NSTextView.h

Availability: OpenStep
Description forthcoming.
Method summary

- -acceptableDragTypes
- -acceptsGlyphInfo
- -allowsDocumentBackgroundColorChange
- -breakUndoCoalescing
- -changeAttributes:
- -changeDocumentBackgroundColor:
- -cleanUpAfterDragOperation
- -clickedOnLink:atIndex:
- -complete:
- -completionsForPartialWordRange:indexOfSelectedItem:
- -dragImageForSelectionWithEvent:origin:
- -dragOperationForDraggingInfo:type:
- -dragSelectionWithEvent:offset:slideBack:
- -drawInsertionPointInRect:color:turnedOn:
- -drawViewBackgroundInRect:
- -insertCompletion:forPartialWordRange:movement:isFinal:
- -orderFrontLinkPanel:
- -orderFrontListPanel:
- -orderFrontTablePanel:
- -performFindPanelAction:
- -preferredPasteboardTypeFromArray:restrictedToTypesFromArray:
- -readSelectionFromPasteboard:
- -readSelectionFromPasteboard:type:
- -readablePasteboardTypes
- -rulerView:didAddMarker:
- -rulerView:didMoveMarker:
- -rulerView:didRemoveMarker:
- -rulerView:handleMouseDown:
- -rulerView:shouldAddMarker:
- -rulerView:shouldMoveMarker:
- -rulerView:shouldRemoveMarker:
- -rulerView:willAddMarker:atLocation:
- -rulerView:willMoveMarker:toLocation:
- -selectedRanges
- -selectionAffinity
- -selectionGranularity
- -selectionRangeForProposedRange:granularity:
- -setAcceptsGlyphInfo:
- -setAllowsDocumentBackgroundColorChange:
- -setNeedsDisplayInRect:avoidAdditionalLayout:
- -setSelectedRange:
- -setSelectedRange:affinity:stillSelecting:
- -setSelectedRanges:
- -setSelectedRanges:affinity:stillSelecting:
- -setSelectionGranularity:
- -setTypingAttributes:
- -shouldDrawInsertionPoint
- -smartDeleteRangeForProposedRange:
- -smartInsertForString:replacingRange:beforeString:afterString:
- -spellCheckerDocumentTag
- -startSpeaking:
- -stopSpeaking:
- -typingAttributes
- -updateDragTypeRegistration
- -updateFontPanel
- -updateInsertionPointStateAndRestartTimer:
- -updateRuler
- -validRequestorForSendType:returnType:
- -writablePasteboardTypes
- -writeSelectionToPasteboard:type:
- -writeSelectionToPasteboard:types:

### acceptableDragTypes

- (NSArray*) acceptableDragTypes;
Availability: OpenStep
Description forthcoming.

### acceptsGlyphInfo

- (BOOL) acceptsGlyphInfo;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### allowsDocumentBackgroundColorChange

- (BOOL) allowsDocumentBackgroundColorChange;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### breakUndoCoalescing

- (void) breakUndoCoalescing;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### changeAttributes:

- (void) changeAttributes: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### changeDocumentBackgroundColor:

- (void) changeDocumentBackgroundColor: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### cleanUpAfterDragOperation

- (void) cleanUpAfterDragOperation;
Availability: OpenStep
Description forthcoming.

### clickedOnLink: atIndex:

- (void) clickedOnLink: (id)link atIndex: (unsigned int)charIndex;
Availability: OpenStep
Description forthcoming.

### complete:

- (void) complete: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### completionsForPartialWordRange: indexOfSelectedItem:

- (NSArray*) completionsForPartialWordRange: (NSRange)range indexOfSelectedItem: (int*)index;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### dragImageForSelectionWithEvent: origin:

- (NSImage*) dragImageForSelectionWithEvent: (NSEvent*)event origin: (NSPoint*)origin;
Availability: OpenStep
Description forthcoming.

### dragOperationForDraggingInfo: type:

- (unsigned int) dragOperationForDraggingInfo: (id)dragInfo type: (NSString*)type;
Availability: OpenStep
Description forthcoming.

### dragSelectionWithEvent: offset: slideBack:

- (BOOL) dragSelectionWithEvent: (NSEvent*)event offset: (NSSize)mouseOffset slideBack: (BOOL)slideBack;
Availability: OpenStep
Description forthcoming.

### drawInsertionPointInRect: color: turnedOn:

- (void) drawInsertionPointInRect: (NSRect)rect color: (NSColor*)color turnedOn: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### drawViewBackgroundInRect:

- (void) drawViewBackgroundInRect: (NSRect)rect;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### insertCompletion: forPartialWordRange: movement: isFinal:

- (void) insertCompletion: (NSString*)word forPartialWordRange: (NSRange)range movement: (int)movement isFinal: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### orderFrontLinkPanel:

- (void) orderFrontLinkPanel: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### orderFrontListPanel:

- (void) orderFrontListPanel: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### orderFrontTablePanel:

- (void) orderFrontTablePanel: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### performFindPanelAction:

- (void) performFindPanelAction: (id)sender;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### preferredPasteboardTypeFromArray: restrictedToTypesFromArray:

- (NSString*) preferredPasteboardTypeFromArray: (NSArray*)availableTypes restrictedToTypesFromArray: (NSArray*)allowedTypes;
Availability: OpenStep
Description forthcoming.

### readSelectionFromPasteboard:

- (BOOL) readSelectionFromPasteboard: (NSPasteboard*)pboard;
Availability: OpenStep
Description forthcoming.

### readSelectionFromPasteboard: type:

- (BOOL) readSelectionFromPasteboard: (NSPasteboard*)pboard type: (NSString*)type;
Availability: OpenStep
Description forthcoming.

### readablePasteboardTypes

- (NSArray*) readablePasteboardTypes;
Availability: OpenStep
Description forthcoming.

### rulerView: didAddMarker:

- (void) rulerView: (NSRulerView*)ruler didAddMarker: (NSRulerMarker*)marker;
Availability: OpenStep
Description forthcoming.

### rulerView: didMoveMarker:

- (void) rulerView: (NSRulerView*)ruler didMoveMarker: (NSRulerMarker*)marker;
Availability: OpenStep
Mote movement of marker

### rulerView: didRemoveMarker:

- (void) rulerView: (NSRulerView*)ruler didRemoveMarker: (NSRulerMarker*)marker;
Availability: OpenStep
Handle removal of marker.

### rulerView: handleMouseDown:

- (void) rulerView: (NSRulerView*)ruler handleMouseDown: (NSEvent*)event;
Availability: OpenStep
Set new marker position from mouse down location.

### rulerView: shouldAddMarker:

- (BOOL) rulerView: (NSRulerView*)ruler shouldAddMarker: (NSRulerMarker*)marker;
Availability: OpenStep
Return `YES` if the marker should be added, `NO` otherwise.

### rulerView: shouldMoveMarker:

- (BOOL) rulerView: (NSRulerView*)ruler shouldMoveMarker: (NSRulerMarker*)marker;
Availability: OpenStep
Return `YES` if the marker should be moved, `NO` otherwise.

### rulerView: shouldRemoveMarker:

- (BOOL) rulerView: (NSRulerView*)ruler shouldRemoveMarker: (NSRulerMarker*)marker;
Availability: OpenStep
Return `YES` if the marker should be removed, `NO` otherwise.

### rulerView: willAddMarker: atLocation:

- (float) rulerView: (NSRulerView*)ruler willAddMarker: (NSRulerMarker*)marker atLocation: (float)location;
Availability: OpenStep
Return a position for adding by constraining the specified location.

### rulerView: willMoveMarker: toLocation:

- (float) rulerView: (NSRulerView*)ruler willMoveMarker: (NSRulerMarker*)marker toLocation: (float)location;
Availability: OpenStep
Return a new position by constraining the specified location.

### selectedRanges

- (NSArray*) selectedRanges;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### selectionAffinity

- (NSSelectionAffinity) selectionAffinity;
Availability: OpenStep
Description forthcoming.

### selectionGranularity

- (NSSelectionGranularity) selectionGranularity;
Availability: OpenStep
Description forthcoming.

### selectionRangeForProposedRange: granularity:

- (NSRange) selectionRangeForProposedRange: (NSRange)proposedCharRange granularity: (NSSelectionGranularity)gr;
Availability: OpenStep
Return a range of text which encompasses proposedCharRange but is extended (if necessary) to match the type of selection specified by gr.

### setAcceptsGlyphInfo:

- (void) setAcceptsGlyphInfo: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setAllowsDocumentBackgroundColorChange:

- (void) setAllowsDocumentBackgroundColorChange: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setNeedsDisplayInRect: avoidAdditionalLayout:

- (void) setNeedsDisplayInRect: (NSRect)rect avoidAdditionalLayout: (BOOL)flag;
Availability: OpenStep
Description forthcoming.

### setSelectedRange:

- (void) setSelectedRange: (NSRange)charRange;
Availability: OpenStep
Description forthcoming.

### setSelectedRange: affinity: stillSelecting:

- (void) setSelectedRange: (NSRange)charRange affinity: (NSSelectionAffinity)affinity stillSelecting: (BOOL)stillSelectingFlag;
Availability: OpenStep
Description forthcoming.

### setSelectedRanges:

- (void) setSelectedRanges: (NSArray*)ranges;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setSelectedRanges: affinity: stillSelecting:

- (void) setSelectedRanges: (NSArray*)ranges affinity: (NSSelectionAffinity)affinity stillSelecting: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setSelectionGranularity:

- (void) setSelectionGranularity: (NSSelectionGranularity)granularity;
Availability: OpenStep
Description forthcoming.

### setTypingAttributes:

- (void) setTypingAttributes: (NSDictionary*)attrs;
Availability: OpenStep
Description forthcoming.

### shouldDrawInsertionPoint

- (BOOL) shouldDrawInsertionPoint;
Availability: OpenStep
Description forthcoming.

### smartDeleteRangeForProposedRange:

- (NSRange) smartDeleteRangeForProposedRange: (NSRange)proposedCharRange;
Availability: OpenStep
Description forthcoming.

### smartInsertForString: replacingRange: beforeString: afterString:

- (void) smartInsertForString: (NSString*)aString replacingRange: (NSRange)charRange beforeString: (NSString**)beforeString afterString: (NSString**)afterString;
Availability: OpenStep
Description forthcoming.

### spellCheckerDocumentTag

- (int) spellCheckerDocumentTag;
Availability: OpenStep
Description forthcoming.

### startSpeaking:

- (void) startSpeaking: (id)sender;
Availability: OpenStep
Description forthcoming.

### stopSpeaking:

- (void) stopSpeaking: (id)sender;
Availability: OpenStep
Description forthcoming.

### typingAttributes

- (NSDictionary*) typingAttributes;
Availability: OpenStep
TODO: categorize

### updateDragTypeRegistration

- (void) updateDragTypeRegistration;
Availability: OpenStep
Description forthcoming.

### updateFontPanel

- (void) updateFontPanel;
Availability: OpenStep
Description forthcoming.

### updateInsertionPointStateAndRestartTimer:

- (void) updateInsertionPointStateAndRestartTimer: (BOOL)restartFlag;
Availability: OpenStep
Description forthcoming.

### updateRuler

- (void) updateRuler;
Availability: OpenStep
Description forthcoming.

### validRequestorForSendType: returnType:

- (id) validRequestorForSendType: (NSString*)sendType returnType: (NSString*)returnType;
Availability: OpenStep
Description forthcoming.

### writablePasteboardTypes

- (NSArray*) writablePasteboardTypes;
Availability: OpenStep
Description forthcoming.

### writeSelectionToPasteboard: type:

- (BOOL) writeSelectionToPasteboard: (NSPasteboard*)pboard type: (NSString*)type;
Availability: OpenStep
Description forthcoming.

### writeSelectionToPasteboard: types:

- (BOOL) writeSelectionToPasteboard: (NSPasteboard*)pboard types: (NSArray*)types;
Availability: OpenStep
Description forthcoming.

Up